
/*************************************************************************

  APU R 2.0

  arith_util.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#include "arith_util.h"

/* computes the floor of log_b (n) */
int 
floor_logb (int n, int b)
{
  double temp;
  int result;

  if (n == 0) 
    return(0);
  temp = log ((double) n) / log ((double) b);
  temp = floor(temp);
  result = (int) temp;

  if (power(b,result) <= n) {
    while (power(b,result+1) <= n)
      result++;
  }
  else {
    while (power(b,result) > n) 
      result--;
  }
  return(result);
}
