
/*************************************************************************

  APU R 2.0

  bigfloat_bigint.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#include "bigfloat.h"
#include "bigint.h"
#include "bigfloat_bigint.h"

BigFloat 
operator+ (const BigInt& a, const BigFloat& b) 
{
  BigFloat result = BigFloat(bigfloat(a.i_value()) + b.f_value());
  return(result);
}

BigFloat 
operator+ (const BigFloat& a, const BigInt& b) 
{
  BigFloat result = BigFloat(a.f_value() + bigfloat(b.i_value()));
  return(result);
}

BigFloat 
operator- (const BigInt& a, const BigFloat& b) 
{
  BigFloat result = BigFloat(bigfloat(a.i_value()) - b.f_value()); 
  return(result);
}

BigFloat 
operator- (const BigFloat& a, const BigInt& b) 
{
  BigFloat result = BigFloat(a.f_value() - bigfloat(b.i_value())); 
  return(result);
}

BigFloat 
operator* (const BigInt& a, const BigFloat& b) 
{
  BigFloat result = BigFloat(bigfloat(a.i_value()) * b.f_value()); 
  return(result);
}

BigFloat 
operator* (const BigFloat& a, const BigInt& b) 
{
  BigFloat result = BigFloat(a.f_value() * bigfloat(b.i_value())); 
  return(result);
}

BigFloat 
operator/ (const BigInt& a, const BigFloat& b) 
{
  BigFloat result = BigFloat(bigfloat(a.i_value()) / b.f_value()); 
  return(result);
}

BigFloat 
operator/ (const BigFloat& a, const BigInt& b) 
{
  BigFloat result = BigFloat(a.f_value() / bigfloat(b.i_value())); 
  return(result);
}

