
/*************************************************************************

  APU R 2.0

  bigint_smallint.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#include "smallint.h"
#include "bigint.h"
#include "bigint_smallint.h"

BigInt 
operator+ (const BigInt& a, const SmallInt& b) 
{
  BigInt result = BigInt(a.i_value() + integer(b.i_value()));
  return(result);
}

BigInt 
operator+ (const SmallInt& a, const BigInt& b) 
{
  BigInt result = BigInt(integer(a.i_value()) + b.i_value());
  return(result);
}

BigInt 
operator- (const BigInt& a, const SmallInt& b) 
{
  BigInt result = BigInt(a.i_value() - integer(b.i_value())); 
  return(result);
}

BigInt 
operator- (const SmallInt& a, const BigInt& b) 
{
  BigInt result = BigInt(integer(a.i_value()) - b.i_value()); 
  return(result);
}

BigInt 
operator* (const BigInt& a, const SmallInt& b) 
{
  BigInt result = BigInt(a.i_value() * integer(b.i_value())); 
  return(result);
}

BigInt 
operator* (const SmallInt& a, const BigInt& b) 
{
  BigInt result = BigInt(integer(a.i_value()) * b.i_value()); 
  return(result);
}

BigInt 
operator/ (const BigInt& a, const SmallInt& b) 
{
  BigInt result = BigInt(a.i_value() / integer(b.i_value())); 
  return(result);
}

BigInt 
operator/ (const SmallInt& a, const BigInt& b) 
{
  BigInt result = BigInt(integer(a.i_value()) / b.i_value()); 
  return(result);
}

BigInt 
operator% (const BigInt& a, const SmallInt& b) 
{
  BigInt result = BigInt (a.i_value() % integer(b.i_value())); 
  return(result);
}

BigInt 
operator% (const SmallInt& a, const BigInt& b) 
{
  BigInt result = BigInt (integer(a.i_value()) % b.i_value()); 
  return(result);
}

