
/*************************************************************************

  APU R 2.0

  binop.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#include "field.h"
#include "binop.h"

Assign::Assign(Field_element& a, const Field_element& b) {
  if (a.type_of() == NOTYPE) {
    switch(b.type_of()) {
      case SLP : (Slp&)(a) = (Slp&)(b); break;
      default : cout << "Can't do assign\n"; break;
    }
  }
  else cout << "Assign(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
}

Plus::Plus(Field_element& c, const Field_element& a,const Field_element& b) {
  cout << "Plus(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
}

Minus::Minus(Field_element& c, const Field_element& a,const Field_element& b) {
  cout << "Minus(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
}

Times::Times(Field_element& c, const Field_element& a,const Field_element& b) {
  cout << "Times(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
}

Divide::Divide(Field_element& c,const Field_element& a,const Field_element& b){
  cout << "Divide(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
}

Mod::Mod(Field_element& c,const Field_element& a,const Field_element& b){
  cout << "Mod(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
}

Equals::Equals(bool& c,const Field_element& a,const Field_element& b){
  cout << "Equals(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
  c = false;
}

NotEquals::NotEquals(bool& c,const Field_element& a,const Field_element& b){
  cout << "NotEquals(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
  c = false;
}

LessThan::LessThan(bool& c,const Field_element& a,const Field_element& b){
  cout << "LessThan(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
  c = false;
}

LessThanEq::LessThanEq(bool& c,const Field_element& a,const Field_element& b){
  cout << "LessThanEq(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
  c = false;
}

GreaterThan::GreaterThan(bool& c,const Field_element& a,const Field_element& b){
  cout << "GreaterThan(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
  c = false;
}

GreaterThanEq::GreaterThanEq(bool& c,const Field_element& a,
				     const Field_element& b) {
  cout << "GreaterThanEq(" << a.class_name() << "," 
		  << b.class_name() << ") undefined\n";
  c = false;
}

IntPower::IntPower(Field_element& c, const Field_element& a,int b) {
  cout << "IntPower(" << a.class_name() << "," 
		  << "int" << ") undefined\n";
}

