
/*************************************************************************

  APU R 2.0

  float_smallint.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#include "smallint.h"
#include "float.h"
#include "float_smallint.h"

Float 
operator+ (const Float& a, const SmallInt& b) 
{
  Float result;
  result = Float(a.f_value() + (double)b.i_value());
  return(result);
}

Float 
operator+ (const SmallInt& a, const Float& b) 
{
  Float result;
  result = Float((double)a.i_value() + b.f_value());
  return(result);
}

Float 
operator- (const Float& a, const SmallInt& b) 
{
  Float result;
  result = Float(a.f_value() - (double)b.i_value()); 
  return(result);
}

Float 
operator- (const SmallInt& a, const Float& b) 
{
  Float result;
  result = Float((double)a.i_value() - b.f_value()); 
  return(result);
}

Float 
operator* (const Float& a, const SmallInt& b) 
{
  Float result;  
  result = Float(a.f_value() * (double)b.i_value()); 
  return(result);
}

Float 
operator* (const SmallInt& a, const Float& b) 
{
  Float result;
  result = Float((double)a.i_value() * b.f_value()); 
  return(result);
}

Float 
operator/ (const Float& a, const SmallInt& b) 
{
  Float result;
  result = Float(a.f_value() / (double)b.i_value()); 
  return(result);
}

Float 
operator/ (const SmallInt& a, const Float& b) 
{
  Float result;
  result = Float((double)a.i_value() / b.f_value()); 
  return(result);
}

