
/*************************************************************************

  APU R 2.0

  smallint.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#include "smallint.h"

const char* SmallInt::Class_name = "SmallInt";

SmallInt 
operator+ (const SmallInt& a, const SmallInt& b) 
{
  SmallInt result;
  result = SmallInt(a.i_value() + b.i_value());
  return(result);
}

SmallInt 
operator- (const SmallInt& a, const SmallInt& b) 
{
  SmallInt result;
  result = SmallInt(a.i_value() - b.i_value()); 
  return(result);
}

SmallInt 
operator- (const SmallInt& a)  // negation operator 
{
  SmallInt result;
  result = SmallInt(-a.i_value());
  return(result);
}

SmallInt 
operator* (const SmallInt& a, const SmallInt& b) 
{
  SmallInt result;
  result = SmallInt(a.i_value() * b.i_value());
  return(result);
}

SmallInt 
operator/ (const SmallInt& a, const SmallInt& b) 
{
  SmallInt result;
  result = SmallInt(a.i_value()/b.i_value());
  return(result);
}

SmallInt 
operator% (const SmallInt& a, const SmallInt& b) 
{
  SmallInt result;
  long temp;
  temp = a.i_value() % b.i_value(); 
  result = SmallInt(temp);
  return(result);
}

SmallInt 
operator^ (const SmallInt& a, int b)
{
  SmallInt result;
  long i;
  result = SmallInt(1);
  for (i=0;i<b;i++) {
    result = result*a;
  }
  return(result);
}

bool 
operator== (const SmallInt& a, const SmallInt& b) 
{
  bool result;
  if (a.i_value() == b.i_value()) result = true;
  else result = false;
  return(result);
}

bool 
operator!= (const SmallInt& a, const SmallInt& b) 
{
  bool result;
  if (a.i_value() != b.i_value()) result = true;
  else result = false;
  return(result);
}

bool 
operator < (const SmallInt& a, const SmallInt& b) 
{
  bool result;
  if (a.i_value() < b.i_value()) result = true;
  else result = false;
  return(result);
}

bool 
operator <= (const SmallInt& a, const SmallInt& b) 
{
  bool result;
  if (a.i_value() <= b.i_value()) result = true;
  else result = false;
  return(result);
}

bool 
operator > (const SmallInt& a, const SmallInt& b) 
{
  bool result;
  if (a.i_value() > b.i_value()) result = true;
  else result = false;
  return(result);
}

bool 
operator >= (const SmallInt& a, const SmallInt& b) 
{
  bool result;
  if (a.i_value() >= b.i_value()) result = true;
  else result = false;
  return(result);
}

bool 
is_zero (const SmallInt& a) 
{
  if (a.i_value() == 0) 
    return(true);
  else return(false);
}

int 
sign (const SmallInt& a) 
{
  if (a.i_value() == 0) return(0);
  else if (a.i_value() < 0) return(-1);
  else return(1);
}
