
/*************************************************************************

  APU R 2.0

  divide.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(DIVIDE_HDR)

#define FE_DIVIDE_HDR

#include "fielddef.h"
#include "fieldtypes.h"

class Divide {
  int type;
  public : 
    Divide();
    Divide(Field_element&, const Field_element&, const Field_element&);
    Divide(Field_element&, const SmallInt&, const SmallInt&);
    Divide(Field_element&, const IntModp&, const IntModp&);
    Divide(Field_element&, const IntModp&, const SmallInt&);
    Divide(Field_element&, const SmallInt&, const IntModp&);
    Divide(Field_element&, const BigInt&, const BigInt&);
    Divide(Field_element&, const SmallInt&, const BigInt&);
    Divide(Field_element&, const BigInt&, const SmallInt&);
    Divide(Field_element&, const Float&, const Float&);
    Divide(Field_element&, const SmallInt&, const Float&);
    Divide(Field_element&, const Float&, const SmallInt&);
    Divide(Field_element&, const BigFloat&, const BigFloat&);
    Divide(Field_element&, const Slp&, const Slp&);
    Divide(Field_element&, const SmallInt&, const Slp&);
    Divide(Field_element&, const Slp&, const SmallInt&);
    Divide(Field_element&, const BigInt&, const Slp&);
    Divide(Field_element&, const Slp&, const BigInt&);
};

inline Divide::Divide() {
}

inline Divide::Divide(Field_element& c, const SmallInt& a, const SmallInt& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const IntModp& a, const IntModp& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const IntModp& a, const SmallInt& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const SmallInt& a, const IntModp& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const BigInt& a, const BigInt& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const SmallInt& a, const BigInt& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const BigInt& a, const SmallInt& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const Float& a, const Float& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const SmallInt& a, const Float& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const Float& a, const SmallInt& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const BigFloat& a, const BigFloat& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const Slp& a, const Slp& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const SmallInt& a, const Slp& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const Slp& a, const SmallInt& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const BigInt& a, const Slp& b) {
  c = a/b;
}

inline Divide::Divide(Field_element& c, const Slp& a, const BigInt& b) {
  c = a/b;
}

#endif
