
/*************************************************************************

  APU R 2.0

  lessthan.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(LESSTHAN_HDR) 
#define LESSTHAN_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class LessThan {
  public : 
    LessThan();
    LessThan(bool&, const Field_element&, const Field_element&); 
    LessThan(bool&, const SmallInt&, const SmallInt&); 
    LessThan(bool&, const BigInt&, const BigInt&); 
    LessThan(bool&, const Float&, const Float&); 
    LessThan(bool&, const BigFloat&, const BigFloat&); 
};

inline LessThan::LessThan() {
}

inline LessThan::LessThan(bool& c, const SmallInt& a, const SmallInt& b) {
  c = (a<b);
}

inline LessThan::LessThan(bool& c, const BigInt& a, const BigInt& b) {
  c = (a<b);
}

inline LessThan::LessThan(bool& c, const Float& a, const Float& b) {
  c = (a<b);
}

inline LessThan::LessThan(bool& c, const BigFloat& a, const BigFloat& b) {
  c = (a<b);
}

#endif
