
/*************************************************************************

  APU R 2.0

  lessthaneq.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(LESSTHANEQ_HDR) 
#define LESSTHANEQ_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class LessThanEq {
  public : 
    LessThanEq();
    LessThanEq(bool&, const Field_element&, const Field_element&); 
    LessThanEq(bool&, const BigInt&, const BigInt&); 
    LessThanEq(bool&, const Float&, const Float&); 
};

inline LessThanEq::LessThanEq() {
}

inline LessThanEq::LessThanEq(bool& c, const BigInt& a, const BigInt& b) {
  c = (a<=b);
}

inline LessThanEq::LessThanEq(bool& c, const Float& a, const Float& b) {
  c = (a<=b);
}

#endif
