
/*************************************************************************

  APU R 2.0

  times.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(TIMES_HDR)

#define TIMES_HDR

#include "fielddef.h"
#include "fieldtypes.h"

class Times {
  int type;
  public : 
    Times();
    Times(Field_element&, const Field_element&, const Field_element&);
    Times(Field_element&, const SmallInt&, const SmallInt&);
    Times(Field_element&, const IntModp&, const IntModp&);
    Times(Field_element&, const SmallInt&, const IntModp&);
    Times(Field_element&, const IntModp&, const SmallInt&);
    Times(Field_element&, const BigInt&, const BigInt&);
    Times(Field_element&, const SmallInt&, const BigInt&);
    Times(Field_element&, const BigInt&, const SmallInt&);
    Times(Field_element&, const Float&, const Float&);
    Times(Field_element&, const SmallInt&, const Float&);
    Times(Field_element&, const Float&, const SmallInt&);
    Times(Field_element&, const BigFloat&, const BigFloat&);
    Times(Field_element&, const Slp&, const Slp&);
    Times(Field_element&, const Slp&, const SmallInt&);
    Times(Field_element&, const SmallInt&, const Slp&);
    Times(Field_element&, const Slp&, const BigInt&);
    Times(Field_element&, const BigInt&, const Slp&);
};

inline Times::Times() {
}

inline 
Times::Times(Field_element& result, const SmallInt& a, const SmallInt& b) {
  result = a*b;
}

inline 
Times::Times(Field_element& result, const IntModp& a, const IntModp& b) {
  result = a*b;
}

inline 
Times::Times(Field_element& result, const IntModp& a, const SmallInt& b) {
  result = a*b;
}

inline 
Times::Times(Field_element& result, const SmallInt& a, const IntModp& b) {
  result = a*b;
}

inline 
Times::Times(Field_element& c, const BigInt& a, const BigInt& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const SmallInt& a, const BigInt& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const BigInt& a, const SmallInt& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const Float& a, const Float& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const SmallInt& a, const Float& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const Float& a, const SmallInt& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const BigFloat& a, const BigFloat& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const Slp& a, const Slp& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const SmallInt& a, const Slp& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const Slp& a, const SmallInt& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const BigInt& a, const Slp& b) {
  c = a*b;
}

inline 
Times::Times(Field_element& c, const Slp& a, const BigInt& b) {
  c = a*b;
}


#endif
