
/*************************************************************************

  APU R 2.0

  field_arithop.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(FIELDAUX1_HDR)
#define FIELDAUX1_HDR

#include "fielddef.h"
#include "binop.h"

template<class Type1, class BinOp> 
void
binary_op2 (Field_element& result,BinOp op, Type1 fe1, Field_element fe2) 
{ 
  switch(fe2.type_of()) {
    case SMALLINT : 
      BinOp(result,fe1,(SmallInt&)(fe2)); break;
    case INTMODP : 
      BinOp(result,fe1,(IntModp&)(fe2)); break;
    case BIGINT : 
      BinOp(result,fe1,(BigInt&)(fe2)); break;
    case FLOAT : 
      BinOp(result,fe1,(Float&)(fe2)); break;
    case BIGFLOAT : 
      BinOp(result,fe1,(BigFloat&)(fe2)); break;
    case RATFLOATF : 
      BinOp(result,fe1,(RatFloatf&)(fe2)); break;
    case SLP : 
      BinOp(result,fe1,(Slp&)(fe2)); break;
    default : BinOp(result,fe1,fe2); break;
  }
}

template<class BinOp>
void
binary_op (Field_element& result, BinOp op, 
	   const Field_element& fe1, const Field_element& fe2) 
{
  switch(fe1.type_of()){
    case SMALLINT : 
      binary_op2(result,op,(SmallInt&)(fe1),fe2); break;
    case INTMODP : 
      binary_op2(result,op,(IntModp&)(fe1),fe2); break;
    case BIGINT : 
      binary_op2(result,op,(BigInt&)(fe1),fe2); break;
    case FLOAT : 
      binary_op2(result,op,(Float&)(fe1),fe2); break;
    case BIGFLOAT : 
      binary_op2(result,op,(BigFloat&)(fe1),fe2); break;
    case RATFLOATF : 
      binary_op2(result,op,(RatFloatf&)(fe1),fe2); break;
    case SLP : 
      binary_op2(result,op,(Slp&)(fe1),fe2); break;
    default : binary_op2(result,op,fe1,fe2); break;
  }
}

/*
inline Field_element 
operator + (const Field_element& a, const Field_element& b) {
  Plus op; Field_element result;
  binary_op(result,op,a,b);
  return(result);
}

inline Field_element 
operator - (const Field_element& a, const Field_element& b) {
  Minus op; Field_element result;
  binary_op(result,op,a,b);
  return(result);
}

inline Field_element 
operator * (const Field_element& a, const Field_element& b) {
  Times op; Field_element result;
  binary_op(result,op,a,b);
  return(result);
}

inline Field_element 
operator / (const Field_element& a, const Field_element& b) {
  Divide op; Field_element result;
  binary_op(result,op,a,b);
  return(result);
}

inline Field_element 
operator % (const Field_element& a, const Field_element& b) {
  Mod op; Field_element result;
  binary_op(result,op,a,b);
  return(result);
}
*/


template<class IntBinOp>
void
int_binary_op (Field_element& result, IntBinOp op, 
	   const Field_element& fe1, int operand2) 
{
  switch(fe1.type_of()){
    case SMALLINT : 
      IntBinOp(result,(SmallInt&)(fe1),operand2); break;
    case INTMODP : 
      IntBinOp(result,(IntModp&)(fe1),operand2); break;
    case BIGINT : 
      IntBinOp(result,(BigInt&)(fe1),operand2); break;
    case FLOAT : 
      IntBinOp(result,(Float&)(fe1),operand2); break;
    case BIGFLOAT : 
      IntBinOp(result,(BigFloat&)(fe1),operand2); break;
    case RATFLOATF : 
      IntBinOp(result,(RatFloatf&)(fe1),operand2); break;
    case SLP : 
      IntBinOp(result,(Slp&)(fe1),operand2); break;
    default : IntBinOp(result,fe1,operand2); break;
  }
}

/*
inline Field_element
operator ^ (const Field_element& a, int operand2) {
  IntPower op; Field_element result;
  int_binary_op(result,op,a,operand2);
  return(result);
}
*/
#endif
