
/*************************************************************************

  APU R 2.0

  field_otherop.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(FIELD_OTHEROP_HDR)
#define FIELD_OTHEROP_HDR

#include "fielddef.h"
#include "binop.h"

template<class Type1, class BinOp> 
void
other_binary_op2 (BinOp op, Type1 fe1, const Field_element fe2) 
{ 
  switch(fe2.type_of()) {
    case SMALLINT : 
      BinOp(fe1,(SmallInt&)(fe2)); break;
    case INTMODP : 
      BinOp(fe1,(IntModp&)(fe2)); break;
    case BIGINT : 
      BinOp(fe1,(BigInt&)(fe2)); break;
    case FLOAT : 
      BinOp(fe1,(Float&)(fe2)); break;
    case BIGFLOAT : 
      BinOp(fe1,(BigFloat&)(fe2)); break;
    case RATFLOAT : 
      BinOp(fe1,(RatFloatf&)(fe2)); break;
    case SLP : 
      BinOp(fe1,(Slp&)(fe2)); break;
    default : BinOp(fe1,fe2); break;
  }
}

template<class BinOp> 
void
other_binary_op3(BinOp op, Field_element& fe1, const Field_element& fe2) 
{
  switch (fe2.type_of()) {
    case SMALLINT : 
      other_binary_op2(op,(SmallInt&)(fe1),(SmallInt&)(fe2)); break;
    case INTMODP : 
      other_binary_op2(op,(IntModp&)(fe1),(IntModp&)(fe2)); break;
    case BIGINT : 
      other_binary_op2(op,(BigInt&)(fe1),(BigInt&)(fe2)); break;
    case FLOAT : 
      other_binary_op2(op,(Float&)(fe1),(Float&)(fe2)); break;
    case BIGFLOAT : 
      other_binary_op2(op,(BigFloat&)(fe1),(BigFloat&)(fe2)); break;
    case RATFLOAT : 
      other_binary_op2(op,(RatFloatf&)(fe1),(RatFloatf&)(fe2)); break;
    case SLP : 
      other_binary_op2(op,(Slp&)(fe1),(Slp&)(fe2)); break;
    default : cout << "Unknown type in other_binary_op3\n"; break;
  }
}

template<class BinOp>
void
other_binary_op (BinOp op, Field_element& fe1, const Field_element& fe2) 
{
  switch(fe1.type_of()){
    case SMALLINT : 
      other_binary_op2(op,(SmallInt&)(fe1),fe2); break;
    case INTMODP : 
      other_binary_op2(op,(IntModp&)(fe1),fe2); break;
    case BIGINT : 
      other_binary_op2(op,(BigInt&)(fe1),fe2); break;
    case FLOAT : 
      other_binary_op2(op,(Float&)(fe1),fe2); break;
    case BIGFLOAT : 
      other_binary_op2(op,(BigFloat&)(fe1),fe2); break;
    case RATFLOAT : 
      other_binary_op2(op,(RatFloatf&)(fe1),fe2); break;
    case SLP : 
      other_binary_op2(op,(Slp&)(fe1),fe2); break;
    case NOTYPE : 
      other_binary_op3(op,fe1,fe2); break;
    default : 
      other_binary_op2(op,fe1,fe2); break;
  }
}

#endif
