
/*************************************************************************

  APU R 2.0

  negate.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(NEGATE_HDR) 
#define NEGATE_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class Negate {
  public : 
    Negate();
    Negate(Field_element&, const Field_element&); 
    Negate(Field_element&, const SmallInt&); 
    Negate(Field_element&, const IntModp&); 
    Negate(Field_element&, const BigInt&); 
    Negate(Field_element&, const Float&); 
    Negate(Field_element&, const BigFloat&); 
    Negate(Field_element&, const Slp&); 
};

inline Negate::Negate() {
}

inline Negate::Negate(Field_element& c, const SmallInt& a) {
  c = -a;
}

inline Negate::Negate(Field_element& c, const IntModp& a) {
  c = -a;
}

inline Negate::Negate(Field_element& c, const BigInt& a) {
  c = -a;
}

inline Negate::Negate(Field_element& c, const Float& a) {
  c = -a;
}

inline Negate::Negate(Field_element& c, const BigFloat& a) {
  c = -a;
}

inline Negate::Negate(Field_element& c, const Slp& a) {
  c = -a;
}

#endif
