
/*************************************************************************

  APU R 2.0

  sign.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(SIGN_HDR) 
#define SIGN_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class Sign {
  public : 
    Sign();
    Sign(int&, const Field_element&); 
    Sign(int&, const SmallInt&); 
    Sign(int&, const BigInt&); 
    Sign(int&, const Float&); 
    Sign(int&, const BigFloat&); 
};

inline Sign::Sign() {
}

inline Sign::Sign(int& c, const SmallInt& a) {
  c = sign(a);
}

inline Sign::Sign(int& c, const BigInt& a) {
  c = sign(a);
}

inline Sign::Sign(int& c, const Float& a) {
  c = sign(a);
}

inline Sign::Sign(int& c, const BigFloat& a) {
  c = sign(a);
}

#endif
