
/*************************************************************************

  APU R 2.0

  greaterthaneq.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(GREATERTHANEQ_HDR) 
#define GREATERTHANEQ_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class GreaterThanEq {
  public : 
    GreaterThanEq();
    GreaterThanEq(bool&, const Field_element&, const Field_element&); 
    GreaterThanEq(bool&, const SmallInt&, const SmallInt&); 
    GreaterThanEq(bool&, const BigInt&, const BigInt&); 
    GreaterThanEq(bool&, const Float&, const Float&); 
    GreaterThanEq(bool&, const BigFloat&, const BigFloat&); 
};

inline GreaterThanEq::GreaterThanEq() {
}

inline 
GreaterThanEq::GreaterThanEq(bool& c,const SmallInt& a,const SmallInt& b) {
  c = (a>=b);
}

inline GreaterThanEq::GreaterThanEq(bool& c,const BigInt& a,const BigInt& b) {
  c = (a>=b);
}

inline GreaterThanEq::GreaterThanEq(bool& c, const Float& a, const Float& b) {
  c = (a>=b);
}

inline 
GreaterThanEq::GreaterThanEq(bool& c, const BigFloat& a, const BigFloat& b) {
  c = (a>=b);
}

#endif
