
/*************************************************************************

  APU R 2.0

  intpower.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(INTPOWER_HDR)

#define INTPOWER_HDR

#include "fielddef.h"
#include "fieldtypes.h"

class IntPower {
  public : 
    IntPower();
    IntPower(Field_element&, const Field_element&, int);
    IntPower(Field_element&, const SmallInt&, int);
    IntPower(Field_element&, const BigInt&, int);
    IntPower(Field_element&, const Float&, int);
    IntPower(Field_element&, const Slp&, int);
    IntPower(Field_element&, const IntModp&, int);
    IntPower(Field_element&, const MultiIntModp&, int);
};

inline IntPower::IntPower() {
}

inline 
IntPower::IntPower(Field_element& result, const SmallInt& a, int b) { 
  result = a^b;
}

inline 
IntPower::IntPower(Field_element& result, const BigInt& a, int b) { 
  result = a^b;
}

inline 
IntPower::IntPower(Field_element& result, const Float& a, int b) { 
  result = a^b;
}

inline 
IntPower::IntPower(Field_element& result, const Slp& a, int b) {
   result = a^b;
}

inline 
IntPower::IntPower(Field_element& result, const IntModp& a, int b) {
   result = a^((long)(b));
}

inline 
IntPower::IntPower(Field_element& result, const MultiIntModp& a, int b) {
   result = a^((long)(b));
}


#endif
