
/*************************************************************************

  APU R 2.0

  plus.h

  (c) 1996, Regents of the University of California. 
  All rights reserved. 

*************************************************************************/
  

#if !defined(PLUS_HDR) 
#define PLUS_HDR

#include "fielddef.h"
#include "fieldtypes.h"


class Plus {
  public : 
    Plus();
    Plus(Field_element&, const Field_element&, const Field_element&); 
    Plus(Field_element&, const SmallInt&, const SmallInt&); 
    Plus(Field_element&, const IntModp&, const IntModp&); 
    Plus(Field_element&, const MultiIntModp&, const MultiIntModp&); 
    Plus(Field_element&, const IntModp&, const SmallInt&); 
    Plus(Field_element&, const SmallInt&, const IntModp&); 
    Plus(Field_element&, const IntModp&, const BigInt&); 
    Plus(Field_element&, const BigInt&, const IntModp&); 
    Plus(Field_element&, const IntModp&, const MultiIntModp&); 
    Plus(Field_element&, const MultiIntModp&, const IntModp&); 
    Plus(Field_element&, const BigInt&, const BigInt&); 
    Plus(Field_element&, const SmallInt&, const BigInt&); 
    Plus(Field_element&, const BigInt&, const SmallInt&); 
    Plus(Field_element&, const Float&, const Float&); 
    Plus(Field_element&, const SmallInt&, const Float&); 
    Plus(Field_element&, const Float&, const SmallInt&); 
    Plus(Field_element&, const BigFloat&, const BigFloat&); 
    Plus(Field_element&, const Slp&, const Slp&); 
    Plus(Field_element&, const SmallInt&, const Slp&); 
    Plus(Field_element&, const Slp&, const SmallInt&); 
    Plus(Field_element&, const BigInt&, const Slp&); 
    Plus(Field_element&, const Slp&, const BigInt&); 
    Plus(Field_element&, const BigFloat&, const BigInt&); 
    Plus(Field_element&, const BigInt&, const BigFloat&); 
};

inline Plus::Plus() {
}

inline Plus::Plus(Field_element& c, const SmallInt& a, const SmallInt& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const IntModp& a, const IntModp& b) {
  c = a+b; }

inline Plus::Plus(Field_element& c, const MultiIntModp& a, const MultiIntModp& b) 
{ c = a+b; }

inline Plus::Plus(Field_element& c, const IntModp& a, const SmallInt& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const SmallInt& a, const IntModp& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const IntModp& a, const BigInt& b) 
{ c = a+b; }

inline Plus::Plus(Field_element& c, const BigInt& a, const IntModp& b) 
{ c = a+b; }

inline Plus::Plus(Field_element& c, const IntModp& a, const MultiIntModp& b) 
{ c = a+b; }

inline Plus::Plus(Field_element& c, const MultiIntModp& a, const IntModp& b) 
{ c = a+b; }

inline Plus::Plus(Field_element& c, const BigInt& a, const BigInt& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const SmallInt& a, const BigInt& b) {
  c = a+b; }

inline Plus::Plus(Field_element& c, const BigInt& a, const SmallInt& b) {
  c = a+b; }

inline Plus::Plus(Field_element& c, const Float& a, const Float& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const SmallInt& a, const Float& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const Float& a, const SmallInt& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const BigFloat& a, const BigFloat& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const Slp& a, const Slp& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const SmallInt& a, const Slp& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const Slp& a, const SmallInt& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const BigInt& a, const Slp& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const Slp& a, const BigInt& b) {
  c = a+b;
}

inline Plus::Plus(Field_element& c, const BigFloat& a, const BigInt& b) {
  c = a+b; }

inline Plus::Plus(Field_element& c, const BigInt& a, const BigFloat& b) {
  c = a+b; }

#endif
