
/*************************************************************************

  APU R 2.0

  poly_interp.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

#if !defined(POLY_INTERP_HDR) 
#define POLY_INTERP_HDR

#include "polynomial.h"
#include "array.h"

Polynomial vanderpolate(Array<Polynomial>, Array<Field_element>,int,
			char*,int=INTMODP);
Array<Polynomial> get_masterpoly_coeffs(int,int,Array<Field_element>);
Array<Field_element> get_mp_coeffs(int,int,Array<Field_element>);
Polynomial get_master_poly(Array<Polynomial>,int,char*); 
Polynomial get_ith_divisor(char*,Field_element,int); 
Field_element get_Qi_eval(int,Array<Field_element>,int,int);
void update_coeffs(Array<Field_element>,Polynomial,Field_element,
		   Array<Polynomial>,int, int,char*,int);
Polynomial make_interpolated_poly(Array<Field_element>,int,char*,int); 
Polynomial vanderpolate_mem(Array<Polynomial>, Array<Field_element> ,
	     int , char* , int = INTMODP);
Polynomial get_sym_quotient_poly(char*, int , int ); 
void get_ith_quotient(Polynomial*,Polynomial, Polynomial, int); 
Polynomial vanderpolate_mem2(Array<Polynomial>, Array<Field_element>,
int, char*, Polynomial*, Polynomial*, Array<Field_element>,int = INTMODP);

void get_mp_coeffs_mem(Array<Field_element>,int,int,Array<Field_element>);
void get_masterpoly_coeffs_mem(Array<Polynomial>,int, Array<Field_element>); 
void get_master_poly_mem(Polynomial*,Array<Polynomial>,int,char*); 
#endif
