/*************************************************************************

  APU R 2.0

  slpaux.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

/* Contains auxiliary inline function definitions which enable easier 
   coding, e.g. the member function slp.op(), can be replaced by
   op(slp) defined here.
*/

#if !defined (SLPAUX_HDR)

#define SLPAUX_HDR

inline int op(const Slp& slp) {
  return(slp.op());
}

inline Slp lchild(const Slp& slp) {
  return(slp.lchild());
}

inline Slp rchild(const Slp& slp) {
  return(slp.rchild());
}

inline Field_element fe_of(const Slp& slp) {
  return(slp.fe_of());
}

inline Field_element* fePtr_of(const Slp& slp) {
  return(slp.fePtr_of());
}

inline Array<int> deriv_computed_array(const Slp& slp) {
  return(slp.deriv_computed_array());
}

inline Array<Slp> deriv_array(const Slp& slp) {
  return(slp.deriv_array());
}

inline Field_element value(const Slp& slp) {
  return(slp.value());
}

inline Field_element* value_ptr(const Slp& slp) {
  return(slp.value_ptr());
}

inline int eval_level(const Slp& slp) {
  return(slp.eval_level());
}

inline bool is_numerical(const Slp& slp) {
  return(slp.is_numerical());
}

inline bool is_variable(const Slp& slp) {
  return(slp.is_variable());
}

inline Variable variable_of(const Slp& slp) {
  return(slp.variable_of());
}

inline Slp anti_deriv_of(const Slp& slp) {
  return(slp.anti_deriv_of());
}

#if DEBUG
inline
DebugClass* debug_info_of(const Slp& slp) {
   if ((Slp_node*)(frep_of(slp)) != 0) 
     return(((Slp_node*)(frep_of(slp)))->debug_info);
}
#endif

#endif
