
/*************************************************************************

  APU R 2.0

  chull.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#if !defined(CHULL_HDR) 
#define CHULL_HDR
#include "intpoint.h"
#include "simplex.h"
#include "edge.h"
#define MAXD 100.0
#define LEPS 0.001

Array<IntPoint> chull_points(Array<IntPoint>); 
Array<IntPoint> chull_points_mem(Array<IntPoint>,double**); 
bool on_hull(IntPoint, Array<IntPoint>, double**);
bool is_edge(IntPoint, IntPoint, Array<IntPoint>, double**);
void update_simpmat(double**, int, IntPoint, double); 
void hull_edges(Array<IntPoint>, Array<Edge>, int*, double**);

#endif
