/*************************************************************************

  APU R 2.0

  edge.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/

#if !defined(EDGE_HDR)
#define EDGE_HDR

#include "globals.h"
#include "intpoint.h"

class Edge { 
  private : 
    int index; 
    IntPoint head; 
    IntPoint tail; 
  public : 
    Edge(); 
    Edge(IntPoint,IntPoint);
    IntPoint edge_head(); 
    IntPoint edge_tail(); 
    void set_index(int); 
    int index_of(); 
};

inline Edge::Edge() {} 

inline Edge::Edge(IntPoint hd, IntPoint tl) {
  head = hd; 
  tail = tl; 
}

inline IntPoint Edge::edge_head() { 
  return head; 
} 

inline IntPoint edge_head(Edge edge) { 
  return edge.edge_head(); 
} 

inline IntPoint Edge::edge_tail() { 
  return tail; 
} 

inline IntPoint edge_tail(Edge edge) { 
  return edge.edge_tail(); 
} 

inline void Edge::set_index(int indx) { 
  index = indx; 
}

inline int Edge::index_of() { 
  return index; 
}

inline int index_of(Edge edge) { 
  return edge.index_of(); 
}

typedef Array<Edge> EdgeArray; 
typedef Array<EdgeArray> EdgeMatrix;  

#endif
