
/*************************************************************************

  APU R 2.0

  sparse_res.h

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#if !defined(SPARSE_RES_HDR) 
#define SPARSE_RES_HDR
#include "file_io.h"
#include "matrix.h"
#include "mixvol.h"
#include "molynomial.h"

typedef Array<Field_element> FeArray; 
typedef Array<Slp> SlpArray; 

Matrix<Slp> res_matrix(Array<Polynomial>,int,bool=false,int=0); 
Matrix<Slp> res_matrix(Array<Molynomial>,int,bool=false,int=0); 
Array<int> nfold_mixvols(Array<Molynomial>); 
void dump_for_far(int,Array<Molynomial>,Array<int>); 
void dump_sites(int,Array<Molynomial>,char*); 
void dump_vols(int,Array<int>,char*); 
int compute_maxmonoms(Array<Molynomial>); 
Array<SlpArray> compute_coeffs(Array<Molynomial>); 

#endif
