
/*************************************************************************

  APU R 2.0

  maple.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  
#include <fstream.h>
#include "globals.h"
#include "polynomial.h"
#include "util.h"

void
print_maple_poly(ostream& os, const Polynomial& poly) {
  if (is_zeropoly(poly)) {
    os << "(0)"; 
  }
  else if (is_terminal(poly)) {
    os << "(" << fe_of(poly) << ")"; 
  }
  else {
    TermNode* temp; 
    temp = (termlist_of(poly)).tnode_of(); 
    os << "("; 
    while (temp->next_of() != 0) {
      os << (variable_of(poly))->name() << "^" << temp->degree_of() << "*";
      print_maple_poly(os,temp->coeff_poly()); 
      os << "+ \n"; 
      temp = temp->next_of();
    }
    os << (variable_of(poly))->name() << "^" << temp->degree_of() << "*";
    print_maple_poly(os,temp->coeff_poly()); 
    os << ")";
  }
}

/* Maple has a bad habit of dumping the term "_buffer" in front of its
   output when it writes to a file. This will move the file marker 
   past the Maple junk 
*/

void
eat_maple_junk(ifstream& inFile)
{
  char c,str[10]; 
  eat_whitespace(inFile);
  inFile.get(c);  
  if (c == '_') 
    inFile >> str; 
  else inFile.putback(c);
}
