
/*************************************************************************

  APU R 2.0

  timing.c

  (c) 1996, Regents of the University of California. All rights reserved. 

  Author : Ashutosh Rege (rege@cs.berkeley.edu)

*************************************************************************/
  

/* get user time */

#ifndef NOT_TIMED

extern "C" {
#include <sys/time.h>
#include <sys/resource.h>
void getrusage();
}
#include <math.h>
#include <stdio.h>
#include "timing.h"


long usertime1 ()
{
  struct rusage res;

  getrusage(RUSAGE_SELF, &res); /* get amount of system resources used */
  return (res.ru_utime.tv_usec);
}

long usertime2 ()
{
  struct rusage res;

  getrusage(RUSAGE_SELF, &res); /* get amount of system resources used */
  return (res.ru_utime.tv_sec);
}

#endif

float Timing(char *s)
{
#ifndef NOT_TIMED
  float result;
  long ut1 = usertime1();
  long ut2 = usertime2();
  result = (float)(ut2) + (float)(ut1)/(1000000.0);
  if(s) 
    fprintf(stderr, " Time %f s  %s\n",result,s);
  else 
    fprintf(stderr, " Time %f s  \n",result);
  fflush(stderr);
#endif
  return(result);
}

